﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
'#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private GoogleMap1 As GoogleMap
#if B4A
	Private GoogleMapsExtras1 As GoogleMapsExtras
	Public LastLocation As Location
	Private Mapfragment1 As MapFragment
	Private rp As RuntimePermissions
#else if B4J
#else if B4i
#end if
	Private pnlMap As B4XView
	Private MapReady As Boolean
End Sub

Public Sub Initialize
	
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")

	Wait For (InitializeMap) Complete (Success As Boolean)
	MapReady = Success
	If MapReady Then
		Log("map ready")
	End If
End Sub

Private Sub InitializeMap As ResumableSub
#if B4J
	GoogleMap1.Initialize2("GoogleMap1", Null, Main.API_KEY)
	pnlMap.AddView(GoogleMap1.AsPane, 0, 0, pnlMap.Width, pnlMap.Height)
	Wait For gmap_Ready
	Return GoogleMap1.IsReady
#Else If B4i
	GoogleMap1.Initialize("GoogleMap1", Main.API_KEY)
	pnlMap.AddView(GoogleMap1, 0, 0, pnlMap.Width, pnlMap.Height)
	GoogleMap1.GetUiSettings.CompassEnabled = True
	GoogleMap1.GetUiSettings.MyLocationButtonEnabled = True
	GoogleMap1.MyLocationEnabled = True
	Return True
#Else if B4A
	Wait For gmap_Ready
	GoogleMap1 = Mapfragment1.GetMap
	If GoogleMap1.IsInitialized Then
		rp.CheckAndRequest(rp.PERMISSION_ACCESS_FINE_LOCATION)
		Wait For B4XPage_PermissionResult (Permission As String, Result As Boolean)
		If Result Then
			GoogleMap1.MyLocationEnabled = True
			GoogleMap1.GetUiSettings.MyLocationButtonEnabled = True
			
			Dim OnMyLocationChangeListener1 As OnMyLocationChangeListener
			OnMyLocationChangeListener1.Initialize("OnMyLocationChangeListener1")
			GoogleMapsExtras1.SetOnMyLocationChangeListener(GoogleMap1, OnMyLocationChangeListener1)
			Wait For OnMyLocationChangeListener1_MyLocationChange(Location1 As Location)
			
			LastLocation = Location1

			Dim CameraPosition1 As CameraPosition = GoogleMap1.CameraPosition
			Dim NewCameraPosition As CameraPosition
			NewCameraPosition.Initialize2(LastLocation.Latitude, LastLocation.Longitude, 15, CameraPosition1.Bearing, CameraPosition1.Tilt)
			GoogleMap1.AnimateCamera(NewCameraPosition)
			
		End If
	End If
	Return GoogleMap1.IsInitialized	
#End If
End Sub

'#if B44
Private Sub OnMyLocationChangeListener1_MyLocationChange(location1 As Location)
	Log("Position changed....")
	LastLocation = location1
	Log(LastLocation.Latitude & "," & LastLocation.Longitude)
End Sub
'#End If

Private Sub B4XPage_Resize (Width As Int, Height As Int)
	#if B4J
	GoogleMap1.AsPane.SetSize(pnlMap.Width, pnlMap.Height)
	#Else If B4i
	If GoogleMap1.IsInitialized Then GoogleMap1.SetLayoutAnimated(0, 1, 0, 0, pnlMap.Width, pnlMap.Height)
	#end if
End Sub
